Loading...
Searching...
No Matches
Opm::NcpLocalResidual< TypeTag > Class Template Reference

Details needed to calculate the local residual in the compositional multi-phase NCP-model . More...

`#include <ncplocalresidual.hh>`

Inheritance diagram for Opm::NcpLocalResidual< TypeTag >:

## Public Member Functions

template<class LhsEval>
void | addPhaseStorage (Dune::FieldVector< LhsEval, numEq > &storage, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx, unsigned phaseIdx) const
| Adds the amount all conservation quantities (e.g.
template<class LhsEval>
void | computeStorage (Dune::FieldVector< LhsEval, numEq > &storage, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx) const
| Evaluate the amount all conservation quantities (e.g.
void | computeFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx) const
| Evaluates the total mass flux of all conservation quantities over a face of a sub-control volume.
void | addAdvectiveFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx) const
| Add the advective mass flux at a given flux integration point.
void | addDiffusiveFlux (RateVector &flux, const ElementContext &elemCtx, unsigned scvfIdx, unsigned timeIdx) const
| Adds the diffusive flux at a given flux integration point.
void | computeSource (RateVector &source, const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx) const
| Calculate the source term of the equation.
template<class LhsEval = Evaluation>
LhsEval | phaseNcp (const ElementContext &elemCtx, unsigned dofIdx, unsigned timeIdx, unsigned phaseIdx) const
| Returns the value of the NCP-function for a phase.

## Detailed Description

template<class TypeTag>
class Opm::NcpLocalResidual< TypeTag >

Details needed to calculate the local residual in the compositional multi-phase NCP-model .

## Member Function Documentation

## addAdvectiveFlux()

template<class TypeTag>

void Opm::NcpLocalResidual< TypeTag >::addAdvectiveFlux | ( | RateVector & | flux,
|  | const ElementContext & | elemCtx,
|  | unsigned | scvfIdx,
|  | unsigned | timeIdx ) const

inline

Add the advective mass flux at a given flux integration point.

## addDiffusiveFlux()

template<class TypeTag>

void Opm::NcpLocalResidual< TypeTag >::addDiffusiveFlux | ( | RateVector & | flux,
|  | const ElementContext & | elemCtx,
|  | unsigned | scvfIdx,
|  | unsigned | timeIdx ) const

inline

Adds the diffusive flux at a given flux integration point.

For the immiscible model, this is a no-op for mass fluxes. For energy it adds the contribution of thermal conduction to the enthalpy flux.

## addPhaseStorage()

template<class TypeTag>
template<class LhsEval>

void Opm::NcpLocalResidual< TypeTag >::addPhaseStorage | ( | Dune::FieldVector< LhsEval, numEq > & | storage,
|  | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | timeIdx,
|  | unsigned | phaseIdx ) const

inline

Adds the amount all conservation quantities (e.g.

phase mass) within a single fluid phase

## computeFlux()

template<class TypeTag>

void Opm::NcpLocalResidual< TypeTag >::computeFlux | ( | RateVector & | flux,
|  | const ElementContext & | elemCtx,
|  | unsigned | scvfIdx,
|  | unsigned | timeIdx ) const

inline

Evaluates the total mass flux of all conservation quantities over a face of a sub-control volume.

## computeSource()

template<class TypeTag>

void Opm::NcpLocalResidual< TypeTag >::computeSource | ( | RateVector & | source,
|  | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | timeIdx ) const

inline

Calculate the source term of the equation.

By default, this method only asks the problem to specify a source term.

## computeStorage()

template<class TypeTag>
template<class LhsEval>

void Opm::NcpLocalResidual< TypeTag >::computeStorage | ( | Dune::FieldVector< LhsEval, numEq > & | storage,
|  | const ElementContext & | elemCtx,
|  | unsigned | dofIdx,
|  | unsigned | timeIdx ) const

inline

Evaluate the amount all conservation quantities (e.g.

phase mass) within a finite sub-control volume.

The documentation for this class was generated from the following file:

- opm/models/ncp/ncplocalresidual.hh